// ftest.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ftest.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Fingerprints(HWND, UINT, WPARAM, LPARAM);

Bitmap *Finger=NULL;

LRESULT CALLBACK ObrProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	static Bitmap *background;
	Graphics *graphics;

	switch (message) 
	{	
	case WM_CREATE:
		background = new Bitmap(hInst,MAKEINTRESOURCEW(IDB_BITMAP1));
		InvalidateRect(hWnd,NULL,TRUE);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);		
		RECT r;
		GetClientRect(hWnd,&r);								
		graphics = new Graphics(hdc);				
		if(Finger) 
			graphics->DrawImage(Finger,(int)(0),(int)(0),Finger->GetWidth(),Finger->GetHeight());	
		else
			graphics->DrawImage(background,(int)(0),(int)(0),background->GetWidth(),background->GetHeight());
		delete graphics;
		EndPaint(hWnd, &ps);
		break;	
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

ATOM XX_MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)ObrProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_FTEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "Obr";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_FTEST);

	return RegisterClassEx(&wcex);
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	GdiplusStartupInput gdiplusStartupInput;
    ULONG_PTR           gdiplusToken;	

	// Initialize common controls
	InitCommonControls();
	// Initializze COM
	CoInitialize(NULL);
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);


	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_FTEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	XX_MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_FTEST);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	CoUninitialize();

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_FTEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_FTEST;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_FTEST);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case ID_FILE_FINGERPRINTS:
			DialogBox(hInst, (LPCTSTR)IDD_DIALOG1, hWnd, (DLGPROC)Fingerprints);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

HWND listbox=NULL, bitmap=NULL;

void WriteEvent(char *idSensor, GRCAP_FINGER_EVENTS event)
{
	char *message = (char*)malloc(strlen(idSensor)+100);
	if(message==NULL) { SendMessage(listbox,LB_ADDSTRING,0,(LPARAM)"Cannot allocate memory!!!"); return; }

	switch (event) {
		case GR_PLUG:
			sprintf(message,"Sensor: %s Event: Plugged",idSensor);
            break;
		case GR_UNPLUG:
			sprintf(message,"Sensor: %s Event: Unplugged",idSensor);
            break;
		case GR_FINGER_DOWN:
			sprintf(message,"Sensor: %s Event: Finger placed",idSensor);
            break;
		case GR_FINGER_UP:
			sprintf(message,"Sensor: %s Event: Finger removed",idSensor);
            break;
		case GR_IMAGE:
			sprintf(message,"Sensor: %s Event: Image captured",idSensor);
            break;
		default:
			sprintf(message,"Sensor: %s Event: %i",idSensor, event);            
	}
	int index = (int) SendMessage(listbox,LB_ADDSTRING,0,(LPARAM)message);
	SendMessage(listbox,LB_SETCURSEL,index,0);
	free(message);
}

struct TRawImage {
	unsigned char* img;	
	unsigned int width;
	unsigned int height;
	int Res;
	unsigned char tmpl[GR_MAX_SIZE_TEMPLATE];
	int tmpl_size;
} _raw = {NULL, 0, 0, 0, "", 0};

void CALLBACK FingerEventHandler(char* idSensor, GRCAP_FINGER_EVENTS event) {
WriteEvent(idSensor, event);
}

void CALLBACK ImageEventHandler(char* idSensor, unsigned int width, unsigned int height, unsigned char* rawImage, int res) 
{
	if(_raw.img!=NULL)free(_raw.img);
	_raw.img= (unsigned char*)malloc(width*height+100);
    memcpy(_raw.img, rawImage, width*height);
	_raw.height = height;
	_raw.width = width;
	_raw.Res = res;
		
	_raw.tmpl_size = GR_MAX_SIZE_TEMPLATE; 
	int result = GrExtract(_raw.img, _raw.width, _raw.height, _raw.Res, (char*)_raw.tmpl, &_raw.tmpl_size, GR_DEFAULT_CONTEXT); 	
	if (result < 0)
	{ 	
		_raw.tmpl_size = 0; 
	}
	WriteEvent(idSensor, GR_IMAGE);
	
	HBITMAP handle; 
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(bitmap, &ps);
	GrBiometricDisplay((char *)_raw.tmpl, _raw.img, _raw.width, _raw.height, _raw.Res, hdc, handle, GR_NO_CONTEXT); 
	if (handle != NULL) 
	{ 
		if(Finger) delete Finger;
        Finger = new Bitmap(handle, NULL);
		InvalidateRect(bitmap,NULL,TRUE);
	} 			
	EndPaint(bitmap, &ps);
}

void CALLBACK StatusEventHandler(char* idSensor, GRCAP_STATUS_EVENTS event) 
{
WriteEvent(idSensor, event);

if (event == GR_PLUG) 
{
    GrCapStartCapture(idSensor, FingerEventHandler, ImageEventHandler);
} 
else 
 if (event == GR_UNPLUG) 
 {
     GrCapStopCapture(idSensor);
 }
}

LRESULT CALLBACK Fingerprints(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int contextId=0;
	int result, retVal;

	switch (message)
	{
	case WM_INITDIALOG:
		listbox=GetDlgItem(hDlg,IDC_LIST1);
		bitmap=GetDlgItem(hDlg,IDC_CUSTOM1);
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_BUTTON1) 
		{
            result = GrInitialize();		
			retVal=GrCreateContext(&contextId);
			retVal=GrCapInitialize(StatusEventHandler);		
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDOK),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON3),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON4),TRUE);
		}
		if (LOWORD(wParam) == IDC_BUTTON3) 
		{
			retVal= GrCapFinalize();		
			retVal=GrDestroyContext(contextId);
			retVal=GrFinalize();
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON3),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_BUTTON4),FALSE);
		}
		if (LOWORD(wParam) == IDC_BUTTON2) 
		{
			OPENFILENAME ofn;       
			char szFile[MAX_PATH]; 
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFile = szFile;			
			ofn.lpstrFile[0] = '\0';
			ofn.nMaxFile = sizeof(szFile);
			ofn.lpstrFilter = "All\0*.*\0JPEG images\0*.jpg\0";
			ofn.nFilterIndex = 1;
			ofn.lpstrFileTitle = NULL;
			ofn.nMaxFileTitle = 0;
			ofn.lpstrInitialDir = NULL;
			ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
			if (GetOpenFileName(&ofn)==TRUE)
                GrCapLoadImageFromFile(ofn.lpstrFile,500);
		}

		if (LOWORD(wParam) == IDC_BUTTON4) 
		{
			struct TRawImage copy;
			copy = _raw;
			_raw.img=NULL;
			if(copy.img==NULL)
			{
				MessageBox(hDlg,"No image is seleted as reference","Error",MB_OK|MB_ICONERROR);
				return TRUE;
			}
			OPENFILENAME ofn;       
			char szFile[MAX_PATH]; 
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFile = szFile;			
			ofn.lpstrFile[0] = '\0';
			ofn.nMaxFile = sizeof(szFile);
			ofn.lpstrFilter = "All\0*.*\0JPEG images\0*.jpg\0";
			ofn.nFilterIndex = 1;
			ofn.lpstrFileTitle = NULL;
			ofn.nMaxFileTitle = 0;
			ofn.lpstrInitialDir = NULL;
			ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
			if (GetOpenFileName(&ofn)==TRUE)
			{
                GrCapLoadImageFromFile(ofn.lpstrFile,500);
				int score, match;
				match=GrVerify((char*)_raw.tmpl,(char*)copy.tmpl,&score, contextId);
				char message[100];
				sprintf(message,"Verification %s, score: %i",(match==GR_MATCH)?"successful":"failed",score);
				if(match==GR_MATCH)
					MessageBox(hDlg,message,"OK",MB_OK|MB_ICONINFORMATION);
				else
					MessageBox(hDlg,message,"Failed",MB_OK|MB_ICONERROR);
			}
			
		}

		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{

			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}